# Striped Horse

## Driver Component

This part of Striped Horse deals with the PPD side of things.

The `.drv` file contains all the different features of all the printers that
are currently supported by Striped Horse. The .drv file allows us to group
common features together so that multiple similar models don't need to have
multiple nearly-identical PPDs.

The `.drv` file is "compiled" using the PPD compiler tool. This looks at all the
different groups inside the .drv and generates a PPD for each model.

The `striped-horse.convs` file describes to CUPS what filters are required to
convert from PDF data to TPCL.

The `striped-horse.types` file describes to CUPS about the MIME types used and
how to detect them.

The `striped-horse.usb-quirks` file tells CUPS to ignore the USB devices, this
is because we support our own method of autodetection.

The `udev` subfolder contains scripts and udev rules for creating and
maintaining CUPS queues.
