#!/bin/sh

FAILED=0

if [ $# -lt 1 ]; then
	echo "No files provided"
	exit 1
fi

for FILE in $*; do
	TECTARGETS=$(grep TECTarget "${FILE}" 2>/dev/null | wc -l)
	if [ "${TECTARGETS}" -gt 1 ]; then
		echo "${FILE}: FAILED: too many TECTarget lines"
		FAILED=1
	elif [ "${TECTARGETS}" -eq 0 ]; then
		echo "${FILE}: FAILED: no TECTarget"
		FAILED=1
	else
		TECTARGET=$(grep TECTarget "${FILE}" | cut -d: -f2)
		echo "${FILE}: PASSED: ${TECTARGET}"
	fi
done

exit ${FAILED}
