#ifndef LEMONGFX_THRESHOLDER_H
#define LEMONGFX_THRESHOLDER_H

#include "gfxtypes.h"

namespace LemonGFX
{
	class Thresholder
	{
	public:
		Thresholder(HalftoningCurve hc)
		: m_curve(hc)
		{
			// kLightest = 0, and kDarkest = 7
			int curveFactor = static_cast<int>(m_curve);
			if (curveFactor < 0 || curveFactor > 6)
				curveFactor = 3; // normal
			
			m_threshold = 32 + (curveFactor * 32);
		}
		
		bool isEnabledForPoint(size_t x, size_t y, unsigned char luminance) const
		{
			(void) x;
			(void) y;
			return luminance < m_threshold;
		}
		
		bool isPure(unsigned char luminance) const
		{
			(void) luminance;
			return true;
		}
	
	private:
		HalftoningCurve m_curve;
		unsigned char m_threshold;
	};
}

#endif

