#include <iostream>
#include "gfxcontext.h"

LemonPDF::Graphics::State::State()
  : lineWidth(1.0),
    lineCapStyle(kButtCap),
    lineJoinStyle(kMiterJoin),
    flatness(0.0),
    miterLimit(10.0),
    renderingIntent(kRelativeColorimetricIntent),
    fillAlpha(1.0),
    strokeAlpha(1.0)
{
}

LemonPDF::Graphics::TextState::TextState()
  : characterSpacing(0),
	wordSpacing(0),
	horizontalScaling(100),
	leading(0),
	fontSize(12.0),
	renderingMode(kFillTextRenderingMode),
	rise(0),
	knockout(false)
{
}

LemonPDF::Graphics::SpacedText::SpacedText()
  : spacing(0.0)
{
}

LemonPDF::Graphics::SpacedText::SpacedText(double spacing, const GlyphData &glyphData)
  : spacing(spacing), glyphData(glyphData)
{
}
