#ifndef LEMONPDF_GFXPATTERN_H
#define LEMONPDF_GFXPATTERN_H

#include <memory>
#include "gfxcolor.h"
#include "pdfexception.h"
#include "pdftypes.h"
#include "gfxtokenstore.h"

namespace LemonPDF
{
	namespace Graphics
	{
		class IContext;

		class Pattern;
		using PatternPtr = std::shared_ptr<Pattern>;

		class Pattern : public Color
		{
		public:
			Pattern();

			virtual void paint(IContext &);
		private:
		};

		class PatternException : public PDFException
		{
		public:
			PatternException(const std::string &msg) : PDFException(msg) {}
		};
	}
}


#endif

