#ifndef LEMONPDF_GFXTILINGPATTERN_H
#define LEMONPDF_GFXTILINGPATTERN_H

#include "gfxpattern.h"
#include "pdfresourcemanager.h"

namespace LemonPDF
{
	namespace Graphics
	{
		class TilingPattern;
		using TilingPatternPtr = std::shared_ptr<TilingPattern>;

		class TilingPattern : public Pattern
		{
		public:
			TilingPattern(ResourceManagerPtr resources, const GFXTokenStore &tokenStore);

			const Rectangle &getBoundingBox() const;
			const TransformMatrix &getMatrix() const;
			const Point &getStep() const;
			void paint(IContext &out) override;
			void setBoundingBox(const Rectangle &rect);
			void setMatrix(const TransformMatrix &matrix);
			void setStep(const Point &step);
		
		private:
			ResourceManagerPtr m_resources;
			GFXTokenStore m_tokenStore;
			Rectangle m_bbox;
			Point m_step;
			TransformMatrix m_matrix;
		};
	}
}

#endif
