#ifndef LEMONPDF_GFXTOKENSTORE_H
#define LEMONPDF_GFXTOKENSTORE_H

#include <iostream>
#include "gfxtokeniser.h"

namespace LemonPDF
{
	namespace Graphics
	{
		class GFXTokenStore : public IGFXTokeniser
		{
		public:
			GFXTokenStore(std::istream &);
			GFXTokenStore(const GFXTokenStore &other);
			GFXTokenStore(GFXTokenStore &&);

			void consume() override;
			GFXToken getNextToken() override;
			GFXToken peekNextToken() override;
			void reset();
		
		private:
			std::vector<GFXToken> m_tokens;
			std::vector<GFXToken>::size_type m_currentToken;
		};
	}
}

#endif
