#include "gfxtruetypefontglyph.h"

LemonPDF::Graphics::TrueTypeFontGlyph::TrueTypeFontGlyph()
{
}

LemonPDF::Graphics::TrueTypeFontGlyph::TrueTypeFontGlyph(const LemonPDF::Graphics::Path &path)
  : m_path(path)
{
}

LemonPDF::Graphics::TrueTypeFontGlyph::TrueTypeFontGlyph(const std::vector<CompositeGlyphInfo> &infos)
  : m_compositeGlyphInfos(infos)
{
}

void LemonPDF::Graphics::TrueTypeFontGlyph::addCompositeGlyphInfo(CompositeGlyphInfo info)
{
	m_compositeGlyphInfos.push_back(info);
}

const LemonPDF::Rectangle &LemonPDF::Graphics::TrueTypeFontGlyph::getBounds() const
{
	return m_bounds;
}

const LemonPDF::Graphics::Path &LemonPDF::Graphics::TrueTypeFontGlyph::getPath() const
{
	return m_path;
}

bool LemonPDF::Graphics::TrueTypeFontGlyph::isComposite() const
{
	return m_compositeGlyphInfos.size() > 0;
}

void LemonPDF::Graphics::TrueTypeFontGlyph::setBounds(const Rectangle &bounds)
{
	m_bounds = bounds;
}
