#ifndef LEMONPDF_GFXTRUETYPEFONTGLYPH_H
#define LEMONPDF_GFXTRUETYPEFONTGLYPH_H

#include <vector>
#include "gfxglyph.h"

namespace LemonPDF
{
	namespace Graphics
	{
		class TrueTypeFontGlyph;
		using TrueTypeFontGlyphPtr = std::shared_ptr<TrueTypeFontGlyph>;

		struct CompositeGlyphInfo
		{
			uint16_t glyphIndex;
			int16_t xOffset;
			int16_t yOffset;
		};

		class TrueTypeFontGlyph : public IGlyph
		{
		public:
			TrueTypeFontGlyph();
			TrueTypeFontGlyph(const Path &path);
			TrueTypeFontGlyph(const std::vector<CompositeGlyphInfo> &infos);

			void addCompositeGlyphInfo(CompositeGlyphInfo glyphInfo);
			const Rectangle &getBounds() const override;
			const Path &getPath() const override;
			void setBounds(const Rectangle &);
			bool isComposite() const;

		private:
			Path m_path;
			Rectangle m_bounds;
			std::vector<CompositeGlyphInfo> m_compositeGlyphInfos;
		};
	}
}

#endif
