#ifndef LEMONPDF_GRAPHICS_TRUETYPEFONTTABLEREADER_H
#define LEMONPDF_GRAPHICS_TRUETYPEFONTTABLEREADER_H

#include <cstdint>
#include <vector>
#include "pdfexception.h"

namespace LemonPDF
{
	namespace Graphics
	{
		class TrueTypeFontTableReader
		{
		public:
			using BufferType = std::vector<unsigned char>;

			TrueTypeFontTableReader(const BufferType &table, BufferType::size_type initialPosition = 0);

			void advance(BufferType::size_type offset);
			BufferType::size_type getCurrentPosition() const;
			const BufferType &getData() const;
			int8_t readInt8();
			int16_t readInt16();
			int32_t readInt32();
			uint8_t readUInt8();
			uint16_t readUInt16();
			uint32_t readUInt32();
			void seek(BufferType::size_type offset);

		private:
			const BufferType &m_table;
			BufferType::size_type m_currentPosition; 
		};
	}
}

#endif
