#ifndef LEMONPDF_PDFCRYPT_ARC4_H
#define LEMONPDF_PDFCRYPT_ARC4_H

// RC4 is a trademarked name, so we use ARC4 which means "apparently RC4"

#include <array>
#include <iostream>
#include <string>
#include <vector>

namespace LemonPDF
{
	namespace Cryptology
	{
		class ARC4
		{
		public:
			ARC4(const std::vector<unsigned char> &secret);
			
			void crypt(std::istream &in, std::ostream &out);
			void crypt(const std::string &in, std::string &out);
			void crypt(std::string &in);

		private:
			unsigned char iterate();

			unsigned char m_i;
			unsigned char m_j;
			std::array<unsigned char, 256> m_keySchedule;
		};
	}
}

#endif
