#include <algorithm>
#include "pdfcrypt-passwordhash.h"

namespace
{
	std::array<unsigned char, 32> g_defaultPassword = {{
		0x28, 0xBF, 0x4E, 0x5E, 0x4E, 0x75, 0x8A, 0x41,
		0x64, 0x00, 0x4E, 0x56, 0xFF, 0xFA, 0x01, 0x08,
		0x2E, 0x2E, 0x00, 0xB6, 0xD0, 0x68, 0x3E, 0x80,
		0x2F, 0x0C, 0xA9, 0xFE, 0x64, 0x53, 0x69, 0x7A
	}};
}

LemonPDF::Cryptography::PasswordHash::PasswordHash()
  : m_password(g_defaultPassword)
{
}

LemonPDF::Cryptography::PasswordHash::PasswordHash(const std::string &password)
  : m_password(g_defaultPassword)
{
	std::string::const_iterator start = password.begin();
	std::string::const_iterator end;

	if (password.size() >= 32)
		end = start + 32;
	else
		end = password.end();

	std::copy(start, end, m_password.begin());
}

LemonPDF::Cryptography::PasswordHash::PasswordHash(const PasswordHash &other)
  : m_password(other.m_password)
{
}

LemonPDF::Cryptography::PasswordHash::PasswordHash(PasswordHash &&other)
  : m_password(std::move(other.m_password))
{
}

unsigned char LemonPDF::Cryptography::PasswordHash::operator[](size_t index) const
{
	return m_password[index];
}
