#ifndef LEMONPDF_PDFCRYPT_PASSWORDHASH_H
#define LEMONPDF_PDFCRYPT_PASSWORDHASH_H

#include <array>
#include <string>

#include "pdfexception.h"

namespace LemonPDF
{
	namespace Cryptography
	{
		class PasswordHash
		{
		public:
			PasswordHash();
			PasswordHash(const std::string &password);
			PasswordHash(const PasswordHash &other);
			PasswordHash(PasswordHash &&other);

			unsigned char operator[](size_t index) const;
			
		private:
			std::array<unsigned char, 32> m_password;
		};

		class PasswordHashException : public LemonPDF::PDFException
		{
		public:
			PasswordHashException(const std::string &msg) : PDFException(msg) {}
		};
	}
}

#endif
