#ifndef LEMONPDF_PDFCRYPTFILTER_STANDARD_H
#define LEMONPDF_PDFCRYPTFILTER_STANDARD_H

#include "pdfcrypt-passwordhash.h"
#include "pdffilter.h"

namespace LemonPDF
{
	namespace Cryptography
	{
		class StandardFilter : public IFilter
		{
		public:
			StandardFilter(const PasswordHash &ownerHash, const PasswordHash &userHash);
			virtual std::string getName() const override;
			virtual void decode(std::istream &in, std::ostream &out) override;
			virtual void encode(std::istream &in, std::ostream &out) override;
		
		private:
			PasswordHash m_ownerHash;
			PasswordHash m_userHash;
		};
	}
}

#endif
