#include <algorithm>
#include <cstdint>
#include <iostream>
#include <unordered_map>
#include <vector>
#include "pdfexception.h"
#include "pdffilter-ccitt.h"

LemonPDF::CCITTFaxDecodeFilter::CCITTFaxDecodeFilter(enum LemonSqueezy::CCITTCompression::Encoding encoding, int errorLines, bool encodedByteAlign, size_t columns, size_t rows, bool endOfBlock, bool blackIs1)
  : m_ccitt(encoding, errorLines, encodedByteAlign, columns, rows, endOfBlock, blackIs1)
{
}

void LemonPDF::CCITTFaxDecodeFilter::decode(std::istream &in, std::ostream &out)
{
	m_ccitt.read(in, out);
}

void LemonPDF::CCITTFaxDecodeFilter::encode(std::istream &in, std::ostream &out)
{
	m_ccitt.write(in, out);
}

std::string LemonPDF::CCITTFaxDecodeFilter::getName() const
{
	return "CCITTFaxDecode";
}