#ifndef LEMONPDF_PDFFILTER_DCT_H
#define LEMONPDF_PDFFILTER_DCT_H 1

#include "pdffilter.h"
#include <functional>

namespace LemonPDF
{
	class DCTDecodeFilter : public LemonPDF::IFilter
	{
	public:
		using ScanlineCallback = std::function<void(const unsigned char *data, size_t bytesPerRow)>;
		DCTDecodeFilter();

		void decode(std::istream &in, std::ostream &out) override;
		void decode(std::istream &in, ScanlineCallback);
		void encode(std::istream &in, std::ostream &out) override;
		std::string getName() const override;
	};
}

#endif
