#ifndef LEMONPDF_PDFFILTER_INFLATE_H
#define LEMONPDF_PDFFILTER_INFLATE_H 1

#include "pdffilter.h"

namespace LemonPDF
{
	class FlateLZWDecodeFilter : public IFilter
	{
	public:
		enum class Mode
		{
			kFlateDecode,
			kLZWDecode
		};

		FlateLZWDecodeFilter(enum Mode mode, unsigned predictor, unsigned colors, unsigned bitsPerComponent, unsigned columns);
		void decode(std::istream &in, std::ostream &out) override;
		void encode(std::istream &in, std::ostream &out) override;
		std::string getName() const override;

	private:
		enum Mode m_mode;
		unsigned m_predictor;
		unsigned m_colors;
		unsigned m_bitsPerComponent;
		unsigned m_columns;
	};
}

#endif
