#ifndef LEMONPDF_PDFFILTER_H
#define LEMONPDF_PDFFILTER_H 1

#include <iostream>
#include <memory>
#include <string>
#include "pdfexception.h"

namespace LemonPDF
{
	class IFilter
	{
	public:
		virtual std::string getName() const = 0;
		virtual void decode(std::istream &in, std::ostream &out) = 0;
		virtual void encode(std::istream &in, std::ostream &out) = 0;
		virtual ~IFilter() {};
	};
	
	typedef std::shared_ptr<IFilter> IFilterPtr;
	
	class PDFFilterException : public PDFException
	{
	public:
		PDFFilterException(const std::string &msg) : PDFException(msg) {}
	};
}

#endif

