#ifndef LEMONPDF_TYPES_H
#define LEMONPDF_TYPES_H

#include <ctime>
#include <string>
#include <libcore/types.h>
#include <libcore/streams.h>

namespace LemonPDF
{
	using Point = StripedHorse::PointF;
	using Rectangle = StripedHorse::RectangleF;
	using TransformMatrix = StripedHorse::TransformMatrix;
	
	using InputVectorStreamBuffer = StripedHorse::BasicInputVectorStreamBuffer<char, unsigned char>;
	using OutputVectorStreamBuffer = StripedHorse::BasicOutputVectorStreamBuffer<char, unsigned char>;

	namespace Types
	{
		std::string CreateTimestamp(time_t t);
		time_t ParseTimestamp(const std::string &value);
	}
}

#endif
