#ifndef LEMONPDF_PJLREADER_H
#define LEMONPDF_PJLREADER_H

#include <iostream>
#include <string>
#include <unordered_map>
#include <vector>

namespace LemonPDF
{
	class PJLReader
	{
	public:
		PJLReader(std::istream &in);
		
		bool extractPrintData(std::ostream &out);
		std::streampos getPrintDataOffset() const;
		const std::string &getCommandSetting(const std::string &commandName, const std::string &settingName, const std::string &defaultValue = "") const;
		bool hasCommandSetting(const std::string &commandName, const std::string &settingName) const;
		bool tryGetCommandSetting(const std::string &commandName, const std::string &settingName, std::string &value) const;
		
	private:
		std::istream &m_input;
		std::streampos m_printDataOffset;
		std::unordered_map<std::string, std::unordered_map<std::string, std::string>> m_settings;
	};
}

#endif
