#ifndef LEMONSQUEEZY_CRC32_H
#define LEMONSQUEEZY_CRC32_H

#include <cstdint>
#include <iostream>
#include <vector>

namespace LemonSqueezy
{
	class CRC32Checksum
	{
	public:
		CRC32Checksum(uint32_t initialValue = 0);

		uint32_t getChecksum() const;
		size_t getLength() const;
		void update(std::istream &in);
		void update(const std::vector<unsigned char> &buffer);
		void update(const unsigned char *buffer, size_t length);

	private:
		uint32_t m_checksum;
		size_t m_length;
	};
}

#endif