#ifndef LEMONSQUEEZY_EXCEPTIONS_H
#define LEMONSQUEEZY_EXCEPTIONS_H

#include <stdexcept>
#include <string>

namespace LemonSqueezy
{
	class Exception : public std::exception
	{
	public:
		Exception(const std::string &msg)
		  : m_msg(msg)
		{
		}

		virtual const char *what() const noexcept
		{
			return m_msg.c_str();
		}
	
	private:
		std::string m_msg;
	};

	class IOException : public Exception
	{
	public:
		IOException(const std::string &msg)
		  : Exception(msg)
		{
		}
	};

	class CompressionException : public Exception
	{
	public:
		CompressionException(const std::string &msg)
		  : Exception(msg)
		{
		}
	};

	class DecompressionException : public Exception
	{
	public:
		DecompressionException(const std::string &msg)
		  : Exception(msg)
		{
		}
	};

	class UnimplementedException : public Exception
	{
	public:
		UnimplementedException(const std::string &msg)
		  : Exception(msg)
		{
		}
	};
}

#endif
