#ifndef LEMONSQUEEZY_COMPRESSION_H
#define LEMONSQUEEZY_COMPRESSION_H

#include <functional>
#include "idecompressor.h"

// unfortunately, JPEG decoding is the only algorithm not hand-made :( ..... yet :D
namespace LemonSqueezy
{
	class JPEGCompression : IDecompressor
	{
	public:
		using ScanlineCallback = std::function<void(const unsigned char *data, size_t bytesPerRow)>;

		JPEGCompression();

		void read(std::istream &in, std::ostream &out) override;
		void read(std::istream &in, ScanlineCallback);

		size_t getSamplesPerPixel() const;

	private:
		size_t m_samplesPerPixel;
	};
}

#endif

