#include "linelengthlimitedencoding.h"

LemonSqueezy::LineLengthLimitedEncoding::LineLengthLimitedEncoding(size_t lineLength, size_t charPosition)
  : m_lineLength(lineLength), m_charPosition(charPosition)
{
	if (m_charPosition >= m_lineLength)
		m_charPosition = 0;
}

void LemonSqueezy::LineLengthLimitedEncoding::put(char c, std::ostream &out)
{
	if (m_lineLength > 0)
	{
		if (m_charPosition == m_lineLength)
		{
			out.put('\n');
			m_charPosition = 0;
		}

		m_charPosition++;
	}

	out.put(c);
}