#ifndef LEMONSQUEEZY_LZW_H
#define LEMONSQUEEZY_LZW_H

#include "icompressor.h"
#include "idecompressor.h"

namespace LemonSqueezy
{
	class LZWCompression : public IDecompressor, public ICompressor
	{
	public:
		enum class TablingSystem
		{
			kDefault, // normal behaviour
			kOffByOne // used by TIFF
		};

		LZWCompression(TablingSystem ts = TablingSystem::kDefault);
		void read(std::istream &in, std::ostream &out) override;
		void write(std::istream &in, std::ostream &out) override;
	
	private:
		TablingSystem m_tablingSystem;
	};
}

#endif
