#ifndef LEMONSQUEEZY_ROLLINGOUTPUTBUFFER_H
#define LEMONSQUEEZY_ROLLINGOUTPUTBUFFER_H

#include <cstdlib>
#include <iostream>
#include <vector>
#include "exceptions.h"

namespace LemonSqueezy
{
	class RollingOutputBuffer
	{
	public:
		RollingOutputBuffer(size_t bufferSize, std::ostream &out);
		~RollingOutputBuffer();

		void flush();
		void put(unsigned char buf);
		void repeatBytes(size_t backwardsDistance, size_t numberOfBytes);

	private:
		using Buffer = std::vector<unsigned char>;

		Buffer m_buffer;
		size_t m_bufferSize;
		size_t m_position;
		std::ostream &m_output;
	};

	class RollingOutputBufferException : public Exception
	{
	public:
		RollingOutputBufferException(const std::string &msg) : Exception(msg) {}
	};
}

#endif
