#ifndef LEMONSQUEEZY_STREAMBITREADER_H
#define LEMONSQUEEZY_STREAMBITREADER_H

#include <iostream>
#include "ibitreader.h"

namespace LemonSqueezy
{
	class StreamBitReader : public IBitReader
	{
	public:
		StreamBitReader(std::istream &in);
		virtual bool appendNextBit(BitSequence &seq) override;
		virtual void alignToByteBoundary() override;
		virtual bool getByte(unsigned char &ch) override;
		virtual bool isAtEndOfStream() const override;
		virtual bool readBitsIntoBitSequence(BitSequence::size_type count, BitSequence &seq) override;
		
	protected:
		bool readNextByte();

		size_t m_bitPosition;
		unsigned char m_currentByte;
		std::istream &m_in;
	};
}

#endif
