#ifndef LEMONSQUEEZY_STREAMBITWRITER_H
#define LEMONSQUEEZY_STREAMBITWRITER_H

#include <iostream>
#include <vector>
#include "ibitwriter.h"

namespace LemonSqueezy
{
	class StreamBitWriter : public IBitWriter
	{
	public:
		StreamBitWriter(std::ostream &out);
		virtual ~StreamBitWriter();
		void alignToByteBoundary() override;
		virtual void ejectByte();
		virtual size_t &getCurrentBitPosition();
		virtual unsigned char &getCurrentByte();
		void writeBits(const BitSequence &bits) override;

	protected:
		size_t m_bitPosition;
		unsigned char m_currentByte;
		std::ostream &m_out;
	
	private:
		static const size_t g_bufferSize;
		unsigned char *m_buffer;
		size_t m_bufferPosition;
		void flush();
	};
}

#endif
