#ifndef LEMONSQUEEZY_ZLIB_H
#define LEMONSQUEEZY_ZLIB_H

#include <cstdint>

#include "icompressor.h"
#include "idecompressor.h"

#include "deflate.h"

namespace LemonSqueezy
{
	class ZLibCompression : public ICompressor, public IDecompressor
	{
	public:
		ZLibCompression();
		virtual ~ZLibCompression();
		
		virtual void read(std::istream &in, std::ostream &out) override;
		virtual void write(std::istream &in, std::ostream &out) override;

		uint32_t getCRC32() const;

	private:
		uint32_t m_crc32;
	};
}

#endif
