#ifndef LEMONXPS_XPSFILE_H
#define LEMONXPS_XPSFILE_H

#include <iostream>
#include <vector>

#include "document.h"
#include "exceptions.h"

namespace LemonXPS
{
	typedef std::vector<DocumentPtr> DocumentSequence;

	class File
	{
	public:
		File(std::istream &input);
		File(const std::string &filename);
		~File();

		void addDocumentSequence(const DocumentSequence &);
		const std::vector<DocumentSequence> &getDocumentSequences() const;

		void write(std::ostream &out);
	
	private:
		std::vector<DocumentSequence> m_documentSequences;
	};

	typedef std::shared_ptr<File> FilePtr;
	typedef std::shared_ptr<const File> FileCPtr;

	class XPSFileException : public XPSException
	{
	public:
		XPSFileException(const std::string &msg) : XPSException(msg) {}
	};
}

#endif

