#ifndef LEMONXPS_LIBXMLHELPER_H
#define LEMONXPS_LIBXMLHELPER_H

#include <functional>
#include <string>
#include <libxml/tree.h>
#include <lemonsqueezy/zip.h>

namespace LemonXPS
{
	namespace XML
	{
		xmlDocPtr CreateXMLDocFromZipArchiveEntry(const LemonSqueezy::ZipArchiveEntry &zae);
		void EnumerateProperties(xmlNodePtr, std::function<void(const std::string &, const std::string &)> callback);
		xmlNodePtr GetFirstElementChild(xmlNodePtr);
		std::string GetName(xmlAttrPtr);
		std::string GetName(xmlNodePtr);
		std::string GetNamespace(xmlNodePtr);
		xmlNodePtr GetNextElementSibling(xmlNodePtr);
		std::string GetProperty(xmlNodePtr, const std::string &name);
		bool HasProperty(xmlNodePtr, const std::string &name);
		bool TryGetProperty(xmlNodePtr, const std::string &name, std::string &value);
	}
}

#endif
