#ifndef LEMONXPS_PATHPARSER_H
#define LEMONXPS_PATHPARSER_H 1

#include <iostream>

namespace LemonXPS
{
	class IPathParserContext
	{
	public:
		using PointType = double;

		virtual void closePath() = 0;
		virtual void curveTo(PointType cx1, PointType cy1, PointType cx2, PointType cy2, PointType x3, PointType y3) = 0;
		virtual void lineTo(PointType x, PointType y) = 0;
		virtual void moveTo(PointType x, PointType y) = 0;
	};

	class PathParser
	{
	public:
		PathParser(std::istream &);
		void render(IPathParserContext &);
	
	private:
		std::istream &m_input;
	};
}

#endif
