#include <cstdint>
#include "endian.h"

static bool g_hostEndianDetermined;
static StripedHorse::Endian g_hostEndian;

StripedHorse::Endian StripedHorse::GetHostEndianness()
{
	if (g_hostEndianDetermined)
		return g_hostEndian;
	
	union
	{
		uint32_t i;
		char c[sizeof i];
	} test = { 0x01020304 };
	
	g_hostEndian = test.c[0] == 1 ? kBigEndian : kLittleEndian;
	g_hostEndianDetermined = true;
	
	return g_hostEndian;
}
