#ifndef STRIPEDHORSE_EXCEPTIONS_H
#define STRIPEDHORSE_EXCEPTIONS_H 1

#include <exception>
#include <string>

namespace StripedHorse
{
	class Exception : public std::exception
	{
	public:
		Exception(const std::string &m) : m_msg(m) {}
		virtual const char *what() const throw() { return m_msg.c_str(); }
		
	protected:
		std::string m_msg;
	};
	
	class IOException : public Exception
	{
	public:
		IOException(const std::string &m) : Exception(m) {}
	};
	
	class InternalInconsistencyException : public Exception
	{
	public:
		InternalInconsistencyException(const std::string &m) : Exception(m) {}
	};
	
	class UnimplementedException : public Exception
	{
	public:
		UnimplementedException(const std::string &m) : Exception(m) {}
	};
	
	class InvalidFormatException : public Exception
	{
	public:
		InvalidFormatException(const std::string &m) : Exception(m) {}
	};

	class InvalidArgumentException : public Exception
	{
	public:
		InvalidArgumentException(const std::string &m) : Exception(m) {}
	};
}

#endif

