#include "rotation.h"

double StripedHorse::DetectAngle(const StripedHorse::TransformMatrix &m)
{
	StripedHorse::PointF p1 = m * StripedHorse::PointF { 0, 0 };
	StripedHorse::PointF p2 = m * StripedHorse::PointF { 1, 0 };
	return std::atan2(p2.y - p1.y, p2.x - p1.x);
}

enum StripedHorse::Rotation StripedHorse::DetectFixedRotation(const StripedHorse::TransformMatrix &m, const double snapping)
{
	return SnapAngleToFixedRotation(DetectAngle(m), snapping);
}

enum StripedHorse::Rotation StripedHorse::SnapAngleToFixedRotation(double angle, const double snapping)
{
	if (std::abs(angle) < snapping)
		return Rotation::kRotate0;
	else if (std::abs(angle - M_PI_2) < snapping)
		return Rotation::kRotate90;
	else if (std::abs(angle - M_PI) < snapping || std::abs(std::abs(angle) - M_PI) < snapping)
		return Rotation::kRotate180;
	else if (std::abs(angle + M_PI_2) < snapping)
		return Rotation::kRotate270;
	else
		return Rotation::kRotateOther;
}
