#ifndef STRIPEDHORSE_ROTATION_H
#define STRIPEDHORSE_ROTATION_H

#include "types.h"

namespace StripedHorse
{
	enum class Rotation
	{
		kRotate0,
		kRotate90,
		kRotate180,
		kRotate270,
		kRotateOther
	};
	
	double DetectAngle(const StripedHorse::TransformMatrix &m);
	enum Rotation DetectFixedRotation(const StripedHorse::TransformMatrix &m, const double snapping = 2.0 / 180.0 * M_PI);
	enum Rotation SnapAngleToFixedRotation(double angle, const double snapping = 2.0 / 180 * M_PI);
}

#endif
