#ifndef STRIPEDHORSE_UUID_H
#define STRIPEDHORSE_UUID_H

#include <array>
#include <cstdint>
#include <string>
#include <vector>

namespace StripedHorse
{
	class UUID
	{
	public:
		static UUID Derive(const std::vector<unsigned char> &);
		static UUID GenerateRandom();
		
		UUID();
		UUID(const std::array<uint8_t, 16> &data);
		UUID(const UUID &);
		UUID(UUID &&);

		const std::array<uint8_t, 16> &getBytes() const;
		explicit operator std::string() const;
		
	private:
		std::array<uint8_t, 16> m_bytes;
	};
}

#endif

