#include <stdexcept>
#include "argumentparser.h"

StripedHorse::ArgumentParser::ArgumentParser(int argc, char **argv)
  : m_usedArgumentValue(false), m_current(0), m_argc(argc), m_argv(argv)
{
}

std::string StripedHorse::ArgumentParser::getArgumentValue()
{
	if (m_current + 1 < m_argc)
	{
		m_usedArgumentValue = true;
		return m_argv[m_current + 1];
	}
	else
	{
		throw std::runtime_error(std::string("Missing argument to ") + m_argv[m_current]);
	}
}

int StripedHorse::ArgumentParser::getCurrentPosition() const
{
	return m_current;
}

void StripedHorse::ArgumentParser::parse(std::function<bool(char)> callback)
{
	while (++m_current < m_argc)
	{
		if (m_argv[m_current][0] != '-')
		{
			return;
		}
		else if (m_argv[m_current][1] == '-')
		{
			// A "--" means to end option parsing
			m_current++;
			return;
		}

		if (!callback(m_argv[m_current][1]))
			throw std::runtime_error(std::string("Unknown argument: ") + m_argv[m_current]);

		if (m_usedArgumentValue)
		{
			m_current++;
			m_usedArgumentValue = false;
		}
	}
}
