#ifndef STRIPEDHORSE_MANAGEDFILE_H
#define STRIPEDHORSE_MANAGEDFILE_H

#include <string>

namespace StripedHorse
{
	// Helper class to ensure file is deleted when the process is done
	// (doesn't apply to crashes, only to clean exit)
	class ManagedFile
	{
	public:
		static void SetManagedFileToStandardInput(ManagedFile &, const std::string &tempPrefix);

		ManagedFile();
		ManagedFile(const ManagedFile &) = delete;
		ManagedFile(ManagedFile &&);
		ManagedFile(const std::string &filename, bool deleteWhenDone = false);
		~ManagedFile();

		const std::string &getFilename() const;
		void setDeleteWhenDone(bool);
		void setFilename(const std::string &filename);

	private:
		std::string m_filename;
		bool m_deleteWhenDone;
	};
}

#endif
