#ifndef STRIPEDHORSE_PPDSTATEMENT_H
#define STRIPEDHORSE_PPDSTATEMENT_H

#include <string>
#include "ppdvalue.h"

namespace StripedHorse
{
	class PPDStatement
	{
	public:
		PPDStatement();
		PPDStatement(size_t ln, const std::string &mainKeyword);
		PPDStatement(size_t ln, const std::string &mainKeyword, const PPDValue &value);
		PPDStatement(size_t ln, const std::string &mainKeyword, const std::string &optionKeyword, const PPDValue &value);
		PPDStatement(size_t ln, const std::string &mainKeyword, const std::string &optionKeyword, const std::string &translation, const PPDValue &value);
		PPDStatement(const PPDStatement &);
		PPDStatement(PPDStatement &&);
		PPDStatement &operator=(const PPDStatement &);
		
		size_t getLineNumber() const;
		const std::string &getMainKeyword() const;
		const std::string &getOptionKeyword() const;
		const std::string &getTranslation() const;
		const PPDValue &getValue() const;
		
		bool hasOptionKeyword() const;
		bool hasTranslation() const;
		bool hasValue() const;
		
	private:
		size_t m_lineNumber;
		std::string m_mainKeyword;
		std::string m_optionKeyword;
		std::string m_translation;
		PPDValue m_value;
	};
}

#endif
