#include "ppdvalue.h"

using namespace StripedHorse;

PPDValue::PPDValue()
  : m_type(kNoValue)
{
}

PPDValue::PPDValue(enum ValueType t, const std::string &value)
  : m_type(t), m_value(value)
{
}

PPDValue::PPDValue(const PPDValue &other)
{
	this->operator=(other);
}

PPDValue::PPDValue(PPDValue &&other)
  : m_type(other.m_type), m_value(std::move(other.m_value))
{
}

PPDValue &PPDValue::operator=(const PPDValue &other)
{
	m_type = other.m_type;
	m_value = other.m_value;
	return *this;
}

PPDValue::ValueType PPDValue::getType() const
{
	return m_type;
}

PPDValue::operator std::string() const
{
	return m_value;
}
