#ifndef STRIPEDHORSE_PPDVALUE_H
#define STRIPEDHORSE_PPDVALUE_H

#include <string>

namespace StripedHorse
{
	class PPDValue
	{
	public:
		enum ValueType
		{
			kInvocationValue,
			kQuotedValue,
			kSymbolValue,
			kStringValue,
			kNoValue
		};
		
		PPDValue();
		PPDValue(enum ValueType, const std::string &value);
		PPDValue(const PPDValue &);
		PPDValue(PPDValue &&);
		PPDValue &operator=(const PPDValue &);
		
		enum ValueType getType() const;
		explicit operator std::string() const;
		
	private:
		enum ValueType m_type;
		std::string m_value;
	};
}

#endif
