#ifndef STRIPEDHORSE_TPCLWRITER_H
#define STRIPEDHORSE_TPCLWRITER_H

#include <iostream>
#include <string>
#include "commands.h"
#include "options.h"

namespace StripedHorse
{
	class TPCLWriter
	{
	public:
		TPCLWriter(std::ostream &out);

		bool doesPutLineFeed() const;
		const std::string &getCommandEnd() const;
		const std::string &getCommandStart() const;
		std::ostream &getStream();
		void setOutputStyle(const std::string &commandStart, const std::string &commandEnd, bool putLineFeed);
		void writeAdjustmentsFromOptions(const Options &options);
		void writeCommandEnd();
		void writeCommandStart(const std::string &cmdName = "");
		void writeString(const std::string &str);

		template <typename ... Args>
		void writeCommand(const std::string &cmd, const Args & ... args)
		{
			writeCommandStart();
			StripedHorse::TPCLCommands::WriteCommand(m_out, cmd, args...);
			writeCommandEnd();
		}

		template <typename ... Args>
		void writeFormat(const std::string &fmt, const Args & ... args)
		{
			StripedHorse::TPCLCommands::WriteCommand(m_out, fmt, args...);
		}

	private:
		std::ostream &m_out;
		std::string m_commandStart;
		std::string m_commandEnd;
		bool m_putLineFeed;
	};
}

#endif
