#ifndef STRIPEDHORSE_WINSOCKHELPER_H
#define STRIPEDHORSE_WINSOCKHELPER_H

#ifdef _WIN32
#define close closesocket

namespace
{
	using ssize_t = SSIZE_T;

	// Win32 doesn't provide read/write, so we instead wrap these around calls
	// to recv and send instead
	inline ssize_t read(int fd, unsigned char *data, int len)
	{
		return recv(fd, reinterpret_cast<char *>(data), len, 0);
	}

	inline ssize_t write(int fd, const char *data, int len)
	{
		return send(fd, data, len, 0);
	}
}
#endif

#endif