#!/bin/sh

if [ -z "$1" -o -z "$2" -o -z "$3" ]; then
	exit 1
fi

# $1 = target name
# $2 = CUPS PPD path for target
# $3 = output filename

TARGET_NAME=$1
TARGET_NAME_UPPER=$(echo ${TARGET_NAME} | tr -- '-[:lower:]' '_[:upper:]')

printf '$(%s_PKG): \\\n' "$TARGET_NAME_UPPER" > "$3"
for FILE in ../drv/ppd/*.ppd; do
	if ! grep -q 'TECTarget:.*unsupported' "${FILE}"; then
		printf '        %s.$(ARCH)%s/%s \\\n' "${TARGET_NAME}" "$2" "$(basename ${FILE})" >> "$3"
	fi
done
printf '\n\n' >> "$3"

