namespace
{
	class UnsupportedUSBDevice
	{
	public:
		bool tryConstructURI(StripedHorse::URI &uri)
		{
			(void) uri;
			return false;
		}

		std::string getDescription()
		{
			return "Unsupported device";
		}

		USBDeviceID getDeviceID() const
		{
			return { 0x08A6, 0xFFFF };
		}

		std::string getIEEE1284DeviceID()
		{
			return "MFG:TOSHIBA;MDL:Barcode Printer;CMD:TPCL;";
		}

		void setConfiguration(uint8_t config)
		{
			(void) config;
		}

		size_t write(std::istream &in)
		{
			(void) in;
			return 0;
		}
	};

	class UnsupportedUSBManager
	{
	public:
		bool tryGetUSBDevices(const USBDeviceIDSet &supportedIDs, std::vector<UnsupportedUSBDevice> &devices, const USBPortPath &portPath = { { 0 } })
		{
			(void) supportedIDs;
			(void) devices;
			(void) portPath;

			StripedHorse::Logging::Warning() << "Device discovery is not available on this system" << std::endl;
			return false;
		}
	};

	using USBManager = UnsupportedUSBManager;
	using USBDevice = UnsupportedUSBDevice;
}
