#include "cmd-feedlabel.h"

void StripedHorse::TECTool::Commands::FeedLabel(Printer &printer, const ArgumentList &args)
{
	bool strip = false;
	int cut = 0;
	int ribbon = 0;
	enum
	{
		none,
		reflective,
		transmissive
	} sensor = none;
	
	for (auto arg : args)
	{
		if (arg == "cut")
			cut = 1;
		else if (arg == "withribbon")
			ribbon = 1;
		else if (arg == "strip")
			strip = true;
		else if (arg == "transmissive")
			sensor = transmissive;
		else if (arg == "reflective")
			sensor = reflective;
		else
			throw InvalidArgumentException("option", arg);
	}
	
	printer.writeCommand("T;abcde", (int) sensor, cut, strip ? "D" : "C", 3, ribbon);
}
