#include <iostream>
#include <libtecfilter/tpclprinterstatus.h>
#include "cmd-getstatus.h"

void StripedHorse::TECTool::Commands::GetStatus(Printer &printer, const ArgumentList &args)
{
	if (args.size() != 0)
		throw InvalidNumberOfArgumentsException(args.size(), 0, 0);
	
	printer.writeCommand("WS");
	
	try
	{
		Buffer buf(13);
		printer.read(buf);
		TPCLPrinterStatus ps(buf);
		
		std::cout << "Status code: " << ps.getStatusCode() << std::endl;
		std::cout << "Remaining count: " << ps.getRemainingCount() << std::endl;
	}
	catch (EmptyTPCLPrinterStatusException &)
	{
		std::cout << "Status code: NO RESPONSE" << std::endl;
		std::cout << "Remaining count: NO RESPONSE" << std::endl;
	}
	catch (InvalidTPCLPrinterStatusException &ex)
	{
		// convert to tectool exception so that exit status is set properly
		throw InvalidResponseException(ex.what());
	}
}
