#include "cmd-setport.h"

void StripedHorse::TECTool::Commands::SetPort(Printer &printer, const ArgumentList &args)
{
	if (args.size() != 1)
		throw InvalidNumberOfArgumentsException(args.size(), 1, 0);
	
	int port = 0;
	
	try
	{
		port = std::stoi(args[0]);
	}
	catch (std::invalid_argument &)
	{
		port = 0;
	}
	catch (std::out_of_range &)
	{
		port = 0;
	}
	
	if (port < 0 || port > 65535)
		port = 0;
	
	printer.writeCommand("IS;a,bbbbb", (port != 0 ? 1 : 0), port);
}
