#!/usr/bin/python

import optparse
import datetime
import sys
import xml.dom.minidom

parser = optparse.OptionParser("usage: %prog [ options ] filename valuename")
parser.add_option("--default", dest="default", help="specify default value if missing", action="store", default=None)
parser.add_option("--to-unix", dest="to_unix", help="convert dates to UNIX timestamps", action="store_true", default=False)

(options, args) = parser.parse_args()

if len(args) < 2:
    parser.error("Missing filename and/or value name")

r = xml.dom.minidom.parse(args[0])
if r.documentElement.hasAttribute(args[1]):
    val = r.documentElement.attributes[args[1]].value
else:
    if options.default is not None:
        print options.default
        sys.exit(0)
    else:
        sys.stderr.write("Missing value for '%s'\n" % args[1])
        sys.exit(1)

if options.to_unix:
    r = datetime.datetime.strptime(val, '%Y-%m-%d')
    epoch = datetime.datetime(1970, 1, 1)
    timestamp = r - epoch
    print (timestamp.microseconds + (timestamp.seconds + timestamp.days * 86400) * 10**6) / 10**6
else:
    print val
