#!/usr/bin/env python

import string
import sys

if len(sys.argv) < 3:
	print("Usage: ")
	print("  %s in-file out-file [ key=value [ key=value ... ] ]" % sys.argv[0])
	sys.exit(1)

substitutions = {}
for arg in sys.argv[3:]:
	equals = arg.find('=')
	if equals == -1:
		raise RuntimeError("syntax is invalid for %s, format is key=value" % arg)
	substitutions[arg[0:equals]] = arg[equals+1:]

infile = open(sys.argv[1], "r")
outfile = open(sys.argv[2], "w")

for line in infile:
	outfile.write(string.Template(line).substitute(substitutions))

