#ifndef STRIPEDHORSE_BITMAPFONT_H
#define STRIPEDHORSE_BITMAPFONT_H

#include <cstdint>
#include <map>
#include <string>

namespace StripedHorse
{
	struct TPCLBitmapFont
	{
		TPCLBitmapFont();
		TPCLBitmapFont(const std::string &name, const std::string &style, double pointSizeAt8dpmm, const std::string &code, int32_t extraDeviceSpacing = 0);

		std::string name;
		std::string style;
		double pointSizeAt8dpmm;
		std::string code;
		bool valid;
		std::map<double, uint32_t> scales;
		int32_t extraDeviceSpacing;
	};

	struct TPCLBitmapFontParameters
	{
		TPCLBitmapFontParameters();
		TPCLBitmapFontParameters(double dpmm, double fontSize, const std::string &fontDescription, bool allowSubstitution);

		TPCLBitmapFont font;

		uint32_t horizontalMagnification;
		uint32_t verticalMagnification;
	};
}

#endif
