#ifndef STRIPEDHORSE_TEMPLATEREPLACEMENT_H
#define STRIPEDHORSE_TEMPLATEREPLACEMENT_H

#include <iostream>
#include <memory>
#include <string>
#include <libcore/types.h>
#include <libcore/rotation.h>
#include <libtecfilter/tpclwriter.h>

namespace StripedHorse
{
	class TemplateObject;
	typedef std::shared_ptr<TemplateObject> TemplateObjectPtr;

	class TemplateObject
	{
	public:
		TemplateObject(const RectangleF &, const std::string &data);
		virtual ~TemplateObject();

		virtual std::string getData() const;
		virtual RectangleF getRegion() const;
		virtual enum Rotation getRotation() const;
		virtual uint32_t getTPCLRotation() const;
		virtual PointF getPlacementPosition(RectangleF::type width, RectangleF::type height) const;
		virtual void setRotation(enum Rotation);
		virtual void write(TPCLWriter &writer, double dpmm) const;

	private:
		RectangleF m_region;
		std::string m_data;
		Rotation m_rotation;
	};
}

#endif
