#include <libtecfilter/commands.h>
#include "tobj-rfid.h"

StripedHorse::RFIDUserMemoryDataTemplateObject::RFIDUserMemoryDataTemplateObject(const RectangleF &region, const std::string &data)
  : TemplateObject(region, data)
{
}

void StripedHorse::RFIDUserMemoryDataTemplateObject::write(TPCLWriter &writer, double dpmm) const
{
	(void) dpmm; // not needed for RFID stuff
	
	std::string data = getData();
	if (data.size() > 0)
		writer.writeCommand("XBaa;bbbb,cccc,d,Tff,Gk,Vs,Btt=w/512", 0, 0, 0, "r", 24, 0, 1, 3, data);
}

StripedHorse::RFIDEPCMemoryDataTemplateObject::RFIDEPCMemoryDataTemplateObject(const RectangleF &region, const std::string &data)
: TemplateObject(region, data)
{
}

void StripedHorse::RFIDEPCMemoryDataTemplateObject::write(TPCLWriter &writer, double dpmm) const
{
	(void) dpmm; // not needed for RFID stuff

	std::string data = getData();
	if (data.size() > 0)
		writer.writeCommand("XBaa;bbbb,cccc,d,Tff,Gk,Vs,Btt=w/512", 0, 0, 0, "r", 24, 0, 1, 1, data);
}
